﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ProtocoloSeguroERapidinho
{
    public class PSR
    {
        private int _versao;
        private int _numeroSequencia;
        private int _portaOrigem;
        private int _portaDestino;
        private int _bits;
        private byte[] _checksum;
        private byte[] _dados;
        private byte[] _pacotao;
        private string[] _nomeDoArquivo; //(Podendo ser download e upload)
        private int[] _tamanhoDeCadaArquivo;
        private int _tamanhoTipo9;

        
        #region PROPRIEDADES
        public int Versao
        {
            get { return _versao; }
            set { _versao = value; } 
        }
        public int TamanhoTipo9
        {
            get { return _tamanhoTipo9; }
            set { _tamanhoTipo9 = value; }
        }
        public int[] TamanhoDeCadaArquivo
        {
            get { return _tamanhoDeCadaArquivo; }
            set { _tamanhoDeCadaArquivo = value; }
        }
        public string[] NomeDoArquivo
        {
            get { return _nomeDoArquivo; }
            set { _nomeDoArquivo = value; }
        }
        public int NumeroSequencia
        {
            get { return _numeroSequencia; }
            set { _numeroSequencia = value; }
        }

        public int PortaOrigem
        {
            get { return _portaOrigem; }
            set { _portaOrigem= value; }
        }

        public int PortaDestino
        {
            get { return _portaDestino; }
            set { _portaDestino= value; }
        }

        public int Bits
        {
            get { return _bits; }
            set { _bits = value; }
        }

        public byte[] CheckSum
        {
            get { return _checksum; }
            set { _checksum= value; }
        }

        public byte[] Dados
        {
            get { return _dados; }
            set { _dados = value; }
        }

        public byte[] Pacotao
        {
            get { return _pacotao; }
            set { _pacotao = value; }
        }

#endregion

         public PSR(byte [] pacote)
        {
            int indice = 0; //Contador x)

            //Inicializa o Pacotao
            //Pacotao = new byte[pacote.Length];
            Pacotao = pacote;

            //Retorna o numero da versão do protocolo
            byte[] arrayVersao = { pacote[indice], 0, 0, 0};
            Versao = Util.MetodosEmGeral.GetInt(arrayVersao);
            indice++;
            
            //Retorna o numero de sequencia no pacote
            byte[] arrayNumeroSequencia = new byte[4];
            for (int i = 0; i < 4; i++)
            {
                arrayNumeroSequencia[i] = pacote[indice];
                indice++;
            }
            NumeroSequencia = Util.MetodosEmGeral.GetInt(arrayNumeroSequencia);

            //Retorna o numero da porta de origem
            byte[] arrayPortaOrigem = { pacote[indice], pacote[indice + 1], 0, 0 };
            indice = indice + 2;
            PortaOrigem = Util.MetodosEmGeral.GetInt(arrayPortaOrigem);

            //Retorna o numero da porta de destino
            byte[] arrayPortaDestino = { pacote[indice], pacote[indice + 1], 0, 0 };
            indice = indice + 2;
            PortaDestino = Util.MetodosEmGeral.GetInt(arrayPortaDestino);

            //Retorna o bit
            byte [] arrayBits = { pacote[indice], 0, 0, 0};
         // Bits = Util.MetodosEmGeral.GetInt(pacote[indice]);
            Bits = Util.MetodosEmGeral.GetInt(arrayBits);
            indice = indice + 1;
            //Retorna o checksum 
            CheckSum = new byte[2];
            CheckSum[0] = pacote[indice];
            indice++;
            CheckSum[1] = pacote[indice];
            indice++;


            #region Dependendo do valor de Bit vamos ter as seguintes opcoes...
            switch (Bits)
            {
                #region CASO SEJA ENVIADO UMA DESCRICAO DO ARQUIVO...
                case 0:
                    //Se for download ou upload os 4 primeiros bytes de dados correspondem a quantidade de
                    //arquivos ou da lista... os 4 bytes seguintes serao o tamanho da string... e depois vem a string
                    byte[] arrayTempTamanho = new byte[4];

                    for (int i = 0; i < 4; i++)
                    {
                        arrayTempTamanho[i] = pacote[indice];
                        indice++;
                    }
                    int tamanhoDaListaDeNomes = Util.MetodosEmGeral.GetInt(arrayTempTamanho);

                    NomeDoArquivo = new string[tamanhoDaListaDeNomes];

                    TamanhoDeCadaArquivo = new int[tamanhoDaListaDeNomes];

                    //Para cada elemento da lista...
                    for (int i = 0; i < tamanhoDaListaDeNomes; i++)
                    {
                        //Recuperar o nome do arquivo...
                        byte[] arrayTamanhoDoNome = new byte[4];

                        for (int k = 0; k < 4; k++)
                        {
                            arrayTamanhoDoNome[k] = pacote[indice];
                            indice++;
                        }

                        int tamanhoDoNome = Util.MetodosEmGeral.GetInt(arrayTamanhoDoNome);

                        byte[] arrayString = new byte[tamanhoDoNome];

                        for (int j = 0; j < tamanhoDoNome; j++)
                        {
                            arrayString[j] = pacote[indice];
                            indice++;
                        }

                        NomeDoArquivo[i] = Util.MetodosEmGeral.GetString(arrayString); //Escrever o nome do arquivo.

                        //Recuperar o tamanho em bytes de cada arquivo...
                        byte[] arrayTempTamanho2 = new byte[4];
                        for (int a = 0; a < 4; a++)
                        {
                            arrayTempTamanho2[a] = pacote[indice];
                            indice++;
                        }

                        TamanhoDeCadaArquivo[i] = Util.MetodosEmGeral.GetInt(arrayTempTamanho2);

                    }


                    break;
                #endregion

                #region CASO O PLAY ESTEJA ATIVADO...
                case 1:
                    Dados = new byte[pacote.Length - 12];
                    int contador = 0;
                    for (int i = 12; i < pacote.Length; i++)
                    {
                        Dados[contador] = pacote[i];
                        contador++;
                    }
                    break;
                #endregion

                #region CASO O PAUSE SEJA ACIONADO...
                case 2:
                    //Não haverá dados...
                    break;
                #endregion

                #region CASO O STOP SEJA ACIONADO...
                case 3:
                    //Não haverá dados...
                    break;
                #endregion

                #region CASO O REINICIAR SEJA ACIONADO...
                case 4:
                    //Não haverá dados...
                    break;
                #endregion

                #region CASO O PACOTE SEJA UM ACK
                case 5:
                    //Não haverá dados...
                    break;
                #endregion

                #region CASO SEJA UM FIM DE CONEXÃO...
                case 6:
                    //Não haverá dados...
                    break;
                #endregion

                #region INFORMANDO QUE O A CONEXÃO AINDA ESTÁ ATIVADA

                case 7:
                    //Nao haverá dados no corpo...
                    break;
                
                #endregion
                
                #region INICIANDO UMA CONEXÃO...

                case 8:
                    break; 
                #endregion

                #region PACOTE TAMANHO DA DESCRICAO
                case 9:
                    byte[] tamanhoArray = { pacote[indice], pacote[indice+1], pacote[indice+2], pacote[indice+3] };
                    TamanhoTipo9 = Util.MetodosEmGeral.GetInt(tamanhoArray);
                    break;
                #endregion

                #region FIM DA CONEXÃO PQ ACABOU O ARQUIVO...

                case 10:
                    break;
                #endregion

                #region OI QUERO DOWNLOAD

                case 11:
                    break;
                #endregion


            } 
            #endregion
        }

        public PSR(int versao, int numeroSequencia, int portaOrigem, int portaDestino,
            int bits, byte[] checksum, byte[] dados)
        {
            
            //Inicializa o tamanho do pacote com 12 (Cabeçalho) + X (Dados do Corpo)
            Pacotao = new byte[12 + dados.Length]; 

            //Salva a Versão do Protocolo no pacote
            Pacotao[0] = Util.MetodosEmGeral.GetByte(versao);
            
            //Salva o numero de sequência no pacote
            byte[] arrayNumeroSequencia = Util.MetodosEmGeral.GetBytes(numeroSequencia);
            int indicex = 1;
            for (int i = 0; i < 4; i++)  
            {
                Pacotao[indicex] = arrayNumeroSequencia[i];
                indicex++;
            }
            
            //Salva o numero da porta de origem no pacote
            byte[] arrayPortaOrigem = Util.MetodosEmGeral.GetBytes(portaOrigem); 
            for (int i = 0; i < 2; i++)
            {
                Pacotao[indicex] = arrayPortaOrigem[i];
                indicex++;
            }

            //Salva o anumero da porta de destino no pacote
            byte[] arrayPortaDestino = Util.MetodosEmGeral.GetBytes(portaDestino); 
            for (int i = 0; i < 2; i++)
            {
                Pacotao[indicex] = arrayPortaDestino[i];
                indicex++;
            }

            //Salva o byte que corresponde ao bit no pacote 
            byte[] bitsArray = Util.MetodosEmGeral.GetBytes(bits);
            Pacotao[indicex] = bitsArray[0];
            indicex++;

            //Salva o CheckSum no pacote
            Pacotao[indicex] = checksum[0];
            indicex++;
            Pacotao[indicex] = checksum[1];
            indicex++;
            //Copia todos os dados para o Pacotao
            dados.CopyTo(Pacotao, indicex);

        }

        
    }
}
